<template lang="pug">
  .right-sidebar(
    :class="{ shown: rightSidebarShown, hidden: !rightSidebarShown, mobile: isMobile }"
    ref="rightSidebar"
  )
    header Export
    .close-button(
      v-html="$icons.close"
      @click="$store.dispatch('rightSidebarShown', false)"
    )
    .content(v-app-scroll)
      export
</template>

<script>
import { mapState } from 'vuex'

export default {
  name: 'RightSidebar',
  computed: {
    ...mapState({
      rightSidebarShown: state => state.editor.rightSidebarShown,
      isMobile: state => state.editor.isMobile
    })
  },
  mounted () {
    window.addEventListener('resize', this.handleWindowResize)
    document.addEventListener('mousedown', this.outsideClick)
  },
  destroyed () {
    window.removeEventListener('resize', this.handleWindowResize)
    document.removeEventListener('mousedown', this.outsideClick)
  },
  methods: {
    outsideClick (event) {
      if (this.$refs.rightSidebar && !this.$refs.rightSidebar.contains(event.target)) {
        this.$store.dispatch('rightSidebarShown', false)
      }
    }
  }
}
</script>

<style lang="scss" scoped>
@import '../../assets/css/mixins';
@import '../../assets/css/variables';

.right-sidebar {
  width: 394px;
  height: 100vh;
  height: calc(var(--vh, 1vh) * 100);
  transition: 0.5s;
  position: absolute;
  bottom: 0;
  background-color: $sidebar-background-color;
  z-index: 40;
  color: #fff;

  header {
    display: flex;
    flex-direction: row;
    align-items: center;
    font-size: 14px;
    height: 56px;
    border-bottom: 1px solid rgba(255, 255, 255, 0.05);
    color: rgba(255, 255, 255, 0.5);
    padding-left: 24px;
  }

  .content {
    height: calc(100% - 54px);
  }

  &.shown {
    right: 0;
    @include delay()
  }

  &.hidden {
    right: -100%;
    @include delay()
  }

  &.mobile {
    width: 100%;
  }
}
</style>
